#include <stdio.h>
#include "xmlParser.h"
#include <nlohmann/json.hpp>
#include <iostream>
#include <string>
using json = nlohmann::json;


void myfree(char *t); // {free(t);}
ToXMLStringTool tx,tx2;

int main(int argc, char **argv)
{

	XMLNode    xmeasData=XMLNode::openFileHelper(argv[1],"measCollecFile").getChildNode("measData");


	XMLElementPosition i=xmeasData.nAttribute(),   // we don't want to list all the attributes
	                   n=xmeasData.nElement();     // there are in total nElement.
//	printf("ii: %i, nn: %i \n",i,n);
	while (i<n)
	{

		XMLNodeContents xContent=xmeasData.enumContents(i);
		XMLNode Node=xContent.child;
		i++;

		XMLNode    xmeasInfo=Node;
		char*  xmeasInfoID;
		char*  jobID;
//		printf("measInfoId: %s\n",xmeasInfo.getAttribute("measInfoId"));
		try
		{
			xmeasInfoID=(char*)xmeasInfo.getAttribute("measInfoId");
		}catch(const std::exception& ex){
			;;
		}

		XMLElementPosition ii=xmeasInfo.nAttribute(),   // we don't want to list all the attributes
		                   nn=xmeasInfo.nElement();     // there are in total nElement.
		std::string Keys[nn];
		int counter=0;		
		//printf("ii: %i, nn: %i \n",ii,nn);
		while (ii<nn)
		{
			XMLNodeContents xnc=xmeasInfo.enumContents(ii);
			if (strcmp(xnc.child.getName(),"job")==0){
				jobID=(char*)xnc.child.getAttribute("jobId");	
			}
			try{
//			printf("a childNode named '%s' and attribute text %s and text %s\n",xnc.child.getName(),xnc.child.getAttribute("p"),xnc.child.getText()); 
			//Keys.push_back(xnc.child.getText());
//			std::cout<<"nn: "<<nn<<"\t ii: "<<ii<<"Keys: "<<sizeof(Keys)/sizeof(std::string)<<std::endl;
			Keys[counter]=std::string(xnc.child.getText());
			counter++;		    
			}catch(const std::exception& ex){
			;;
			}
			ii++;
		}
		    XMLNode    xmeasValue=Node.getChildNode("measValue");
		XMLElementPosition iii=xmeasValue.nAttribute(),   // we don't want to list all the attributes
		                   nnn=xmeasValue.nElement();     // there are in total nElement.
//		printf("iii: %i, nnn: %i \n",iii,nnn);
		while (iii<nnn)
		{
		    XMLNodeContents xnc=xmeasValue.enumContents(iii);
//		    printf("a childNode named '%s' and attribute text %s and text %s\n",xnc.child.getName(),xnc.child.getAttribute("p"),xnc.child.getText()); 
		    //std::cout<<xmeasInfoID<<"$$"<<jobID<<"$$"<<Keys[iii]<<"=="<<xnc.child.getText()<<std::endl;
			printf("%s,%s,%s=%s\n",xmeasInfoID,jobID,Keys[iii-1].c_str(),xnc.child.getText());
		    iii++;
		}
	}
//		std::cout<<"Counter: "<<counter<<std::endl;
    return 0;
}

#ifdef _USE_XMLPARSER_DLL
    void myfree(char *t){freeXMLString(t);}
#else
    void myfree(char *t){free(t);}
#endif
